【POJ】2976 Dropping tests 01分数规划

2024-09-05 15:38

本文主要是介绍【POJ】2976 Dropping tests 01分数规划,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

传送门:【POJ】2976 Dropping tests


题目大意:给你长度为n的一对整数a[],b[](注意是一对的),根据式子可以得到:∑a[ i ] / ∑b[ i ],现在给你整数k,你可以从n个中剔除k对,问剩下的根据式子能得到的最大值是多少,答案*100并且四舍五入精确到个位。


题目分析:

很清晰的01分数规划,设Q(L) = ∑a[ i ] - L * ∑b[ i ]。则Q(L) < 0时能得到更优解,Q(L) > 0时不能得到最优解,Q(L) = 0时是解。

用二分就Q(L) < 0的时候修改下界,Q(L) > 0的时候修改上界。注意精度问题即可。


二分代码如下:


#include <cmath>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std ;#define REP( i , n ) for ( int i = 0 ; i < n ; ++ i )
#define REPF( i , a , b ) for ( int i = a ; i <= b ; ++ i )
#define REPV( i , a , b ) for ( int i = a ; i >= b ; -- i )
#define clear( a , x ) memset ( a , x , sizeof a )const int MAXN = 1005 ;
const double INF = 1e18 ;
const double eps = 1e-6 ;int a[MAXN] , b[MAXN] ;
double c[MAXN] ;
int n , k ;double solve ( double r ) {REP ( i , n )c[i] = a[i] - r * b[i] ;sort ( c , c + n ) ;double ans = 0 ;REPF ( i , k , n - 1 )ans += c[i] ;return ans ;
}void work () {while ( ~scanf ( "%d%d" , &n , &k ) && ( n || k ) ) {REP ( i , n )scanf ( "%d" , &a[i] ) ;REP ( i , n )scanf ( "%d" , &b[i] ) ;double l = 0 , r = INF , m ;while ( fabs ( r - l ) > eps ) {double m = ( l + r ) / 2 ;if ( solve ( m ) >= eps )l = m ;elser = m ;}printf ( "%d\n" , ( int ) ( 100 * l + 0.5 ) ) ;}
}int main () {work () ;return 0 ;
}

然后是迭代的代码:


#include <cmath>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std ;#define REP( i , n ) for ( int i = 0 ; i < n ; ++ i )
#define REPF( i , a , b ) for ( int i = a ; i <= b ; ++ i )
#define REPV( i , a , b ) for ( int i = a ; i >= b ; -- i )
#define clear( a , x ) memset ( a , x , sizeof a )const int MAXN = 1005 ;
const double INF = 1e18 ;
const double eps = 1e-5 ;struct Node {int a , b ;double c ;bool operator < ( const Node &t ) const {return c > t.c ;}
} ;Node node[MAXN] ;
int n , k ;double solve ( double r ) {REP ( i , n )node[i].c = node[i].a - r * node[i].b ;sort ( node , node + n ) ;double A = 0 , B = 0 ;REP ( i , n - k )A += node[i].a , B += node[i].b ;return A / B ;
}void work () {while ( ~scanf ( "%d%d" , &n , &k ) && ( n || k ) ) {REP ( i , n )scanf ( "%d" , &node[i].a ) ;REP ( i , n )scanf ( "%d" , &node[i].b ) ;double res = 0 , tmp ;while ( 1 ) {tmp = solve ( res ) ;if ( fabs ( res - tmp ) <= eps )break ;res = tmp ;}printf ( "%.0f\n" , 100 * res ) ;}
}int main () {work () ;return 0 ;
}


这篇关于【POJ】2976 Dropping tests 01分数规划的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1139372

相关文章

动态规划---打家劫舍

题目: 你是一个专业的小偷,计划偷窃沿街的房屋。每间房内都藏有一定的现金,影响你偷窃的唯一制约因素就是相邻的房屋装有相互连通的防盗系统,如果两间相邻的房屋在同一晚上被小偷闯入,系统会自动报警。 给定一个代表每个房屋存放金额的非负整数数组,计算你 不触动警报装置的情况下 ,一夜之内能够偷窃到的最高金额。 思路: 动态规划五部曲: 1.确定dp数组及含义 dp数组是一维数组,dp[i]代表

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一